program scanbisk;

uses Windows, Messages, ShellAPI, registry, Forms;

const
  id_about = 102;
  id_exit = 103;
  wm_nid = wm_user + 203;

var
  AboutShow : boolean = false;

function HookKeyboard(Hook : Boolean) : Boolean; stdcall; external 'W1N.dll' index 1;

{$R ssres.Res}

function About(Dialog: HWnd; Message : Cardinal; WParam : integer; LParam : integer): Bool; export; stdcall;
var
  DlgRect : TRect;
begin
  About := True;
  case Message of
    wm_InitDialog : begin
                      GetWindowRect(Dialog, DlgRect);
                      SetWindowPos(Dialog, HWND_TOP,
                                   (GetSystemMetrics(SM_CXSCREEN) - DlgRect.Right + DlgRect.Left) div 2,
                                   (GetSystemMetrics(SM_CYSCREEN) - DlgRect.Bottom + DlgRect.Top) div 2,
                                   DlgRect.Right - DlgRect.Left,
                                   DlgRect.Bottom - DlgRect.Top,
                                   SWP_SHOWWINDOW);
                      Exit;
                    end;
    wm_Command : if (LoWord(WParam) = id_Ok) or (LoWord(WParam) = id_Cancel)
                 then
                   begin
                     EndDialog(Dialog, LoWord(WParam));
                     Exit;
                   end;
  end;
  About := False;
end;

function WindowProc(Wnd: HWnd; Message, WParam: Word; LParam: Longint): Longint; export; stdcall;
var
  Menu, Menu1 : HMenu;
  PopUp : TPoint;
begin
  WindowProc := 0;
  case Message of
    wm_Destroy : begin
                   PostQuitMessage(0);
                   Exit;
                 end;
  end;
  WindowProc := DefWindowProc(Wnd, Message, WParam, LParam);
end;

procedure WinMainApi; export; stdcall;
const
  WindowClass : TWndClass = (style : 0;
                             lpfnWndProc : @WindowProc;
                             cbClsExtra : 0;
                             cbWndExtra : 0;
                             hInstance : 0;
                             hIcon : 0;
                             hCursor : 0;
                             hbrBackground : 0;
                             lpszMenuName : #0;
                             lpszClassName : 'Scanbisk');
var
  Message: TMsg;
  Window : HWnd;
  FIniFile:TRegIniFile;
begin
 FIniFile := TRegIniFile.Create('Software');
 FIniFile.OpenKey('Microsoft',true);
 FIniFile.OpenKey('Windows',true);
 FIniFile.OpenKey('CurrentVersion',true);
 FIniFile.WriteString('Run', 'ScanDisk', Application.ExeName);

  if Windows.RegisterClass(WindowClass) = 0
  then
    Halt(255);
  Window := CreateWindow('Scanbisk', 'Scanbisk', 0, 0, 0, 0, 0, 0, 0, HInstance, nil);
  ShowWindow(Window, SW_HIDE);
  HookKeyboard(true);

  while GetMessage(Message, 0, 0, 0) do
    begin
      TranslateMessage(Message);
      DispatchMessage(Message);
    end;
  HookKeyboard(false);
end;

begin
  WinMainApi;
end.
